kernel: remove debug code from module insert script
[openwrt/svn-archive/archive.git] / include / kernel.mk
1 #
2 # Copyright (C) 2006-2011 OpenWrt.org
3 #
4 # This is free software, licensed under the GNU General Public License v2.
5 # See /LICENSE for more information.
6 #
7
8 ifeq ($(__target_inc),)
9 include $(INCLUDE_DIR)/target.mk
10 endif
11
12 ifeq ($(DUMP),1)
13 KERNEL?=<KERNEL>
14 BOARD?=<BOARD>
15 LINUX_VERSION?=<LINUX_VERSION>
16 LINUX_VERMAGIC?=<LINUX_VERMAGIC>
17 else
18 ifeq ($(CONFIG_EXTERNAL_TOOLCHAIN),)
19 export GCC_HONOUR_COPTS=s
20 endif
21
22 LINUX_KMOD_SUFFIX=ko
23
24 ifneq (,$(findstring uml,$(BOARD)))
25 KERNEL_CC?=$(HOSTCC)
26 KERNEL_CROSS?=
27 else
28 KERNEL_CC?=$(TARGET_CC)
29 KERNEL_CROSS?=$(TARGET_CROSS)
30 endif
31
32 ifeq ($(TARGET_BUILD),1)
33 PATCH_DIR ?= ./patches$(if $(wildcard ./patches-$(KERNEL_PATCHVER)),-$(KERNEL_PATCHVER))
34 FILES_DIR ?= $(foreach dir,$(wildcard ./files ./files-$(KERNEL_PATCHVER)),"$(dir)")
35 endif
36 KERNEL_BUILD_DIR ?= $(BUILD_DIR)/linux-$(BOARD)$(if $(SUBTARGET),_$(SUBTARGET))
37 LINUX_DIR ?= $(KERNEL_BUILD_DIR)/linux-$(LINUX_VERSION)
38 ifeq ($(strip $(call CompareKernelPatchVer,$(KERNEL_PATCHVER),ge,3.7.0)),1)
39 LINUX_UAPI_DIR=uapi/
40 endif
41 LINUX_VERMAGIC:=$(strip $(shell cat $(LINUX_DIR)/.vermagic 2>/dev/null))
42 LINUX_VERMAGIC:=$(if $(LINUX_VERMAGIC),$(LINUX_VERMAGIC),unknown)
43
44 LINUX_UNAME_VERSION:=$(if $(word 3,$(subst ., ,$(KERNEL_BASE))),$(KERNEL_BASE),$(KERNEL_BASE).0)
45 ifneq ($(findstring -rc,$(LINUX_VERSION)),)
46 LINUX_UNAME_VERSION:=$(LINUX_UNAME_VERSION)-$(strip $(lastword $(subst -, ,$(LINUX_VERSION))))
47 endif
48
49 MODULES_SUBDIR:=lib/modules/$(LINUX_UNAME_VERSION)
50 TARGET_MODULES_DIR := $(LINUX_TARGET_DIR)/$(MODULES_SUBDIR)
51
52 LINUX_KERNEL:=$(KERNEL_BUILD_DIR)/vmlinux
53
54 LINUX_SOURCE:=linux-$(LINUX_VERSION).tar.xz
55 TESTING:=$(if $(findstring -rc,$(LINUX_VERSION)),/testing,)
56 ifeq ($(call qstrip,$(CONFIG_EXTERNAL_KERNEL_TREE))$(call qstrip,$(CONFIG_KERNEL_GIT_CLONE_URI)),)
57 LINUX_SITE:=@KERNEL/linux/kernel/v3.x$(TESTING)
58 endif
59
60 ifneq ($(TARGET_BUILD),1)
61 PKG_BUILD_DIR ?= $(KERNEL_BUILD_DIR)/$(PKG_NAME)$(if $(PKG_VERSION),-$(PKG_VERSION))
62 endif
63 endif
64
65 ifneq (,$(findstring uml,$(BOARD)))
66 LINUX_KARCH=um
67 else
68 ifeq (,$(LINUX_KARCH))
69 LINUX_KARCH=$(strip $(subst i386,x86,$(subst armeb,arm,$(subst mipsel,mips,$(subst mips64,mips,$(subst mips64el,mips,$(subst sh2,sh,$(subst sh3,sh,$(subst sh4,sh,$(ARCH))))))))))
70 endif
71 endif
72
73
74 define KernelPackage/Defaults
75 FILES:=
76 AUTOLOAD:=
77 endef
78
79 define ModuleAutoLoad
80 $(SH_FUNC) \
81 export modules=; \
82 probe_module() { \
83 mods="$$$$$$$$1"; \
84 boot="$$$$$$$$2"; \
85 shift 2; \
86 for mod in $$$$$$$$mods; do \
87 if [ -e $(2)/$(MODULES_SUBDIR)/$$$$$$$$mod.ko ]; then \
88 mkdir -p $(2)/etc/modules.d; \
89 echo "$$$$$$$$mod" >> $(2)/etc/modules.d/$(1); \
90 fi; \
91 done; \
92 if [ -e $(2)/etc/modules.d/$(1) ]; then \
93 if [ "$$$$$$$$boot" = "1" ]; then \
94 mkdir -p $(2)/etc/modules-boot.d; \
95 ln -s ../modules.d/$(1) $(2)/etc/modules-boot.d/; \
96 fi; \
97 modules="$$$$$$$${modules:+$$$$$$$$modules}"; \
98 fi; \
99 }; \
100 add_module() { \
101 priority="$$$$$$$$1"; \
102 mods="$$$$$$$$2"; \
103 boot="$$$$$$$$3"; \
104 shift 3; \
105 for mod in $$$$$$$$mods; do \
106 if [ -e $(2)/$(MODULES_SUBDIR)/$$$$$$$$mod.ko ]; then \
107 mkdir -p $(2)/etc/modules.d; \
108 echo "$$$$$$$$mod" >> $(2)/etc/modules.d/$$$$$$$$priority-$(1); \
109 fi; \
110 done; \
111 if [ -e $(2)/etc/modules.d/$$$$$$$$priority-$(1) ]; then \
112 if [ "$$$$$$$$boot" = "1" ]; then \
113 mkdir -p $(2)/etc/modules-boot.d; \
114 ln -s ../modules.d/$$$$$$$$priority-$(1) $(2)/etc/modules-boot.d/; \
115 fi; \
116 modules="$$$$$$$${modules:+$$$$$$$$modules }$$$$$$$$priority-$(1)"; \
117 fi; \
118 }; \
119 $(3) \
120 if [ -n "$$$$$$$$modules" ]; then \
121 mkdir -p $(2)/etc/modules.d; \
122 mkdir -p $(2)/CONTROL; \
123 echo "#!/bin/sh" > $(2)/CONTROL/postinst; \
124 echo "[ -z \"\$$$$$$$$IPKG_INSTROOT\" ] || exit 0" >> $(2)/CONTROL/postinst; \
125 echo ". /lib/functions.sh" >> $(2)/CONTROL/postinst; \
126 echo "insert_modules $$$$$$$$modules" >> $(2)/CONTROL/postinst; \
127 chmod 0755 $(2)/CONTROL/postinst; \
128 fi
129 endef
130
131 ifeq ($(DUMP)$(TARGET_BUILD),)
132 -include $(LINUX_DIR)/.config
133 endif
134
135 define KernelPackage/depends
136 $(STAMP_BUILT): $(LINUX_DIR)/.config
137 define KernelPackage/depends
138 endef
139 endef
140
141 define KernelPackage
142 NAME:=$(1)
143 $(eval $(call Package/Default))
144 $(eval $(call KernelPackage/Defaults))
145 $(eval $(call KernelPackage/$(1)))
146 $(eval $(call KernelPackage/$(1)/$(BOARD)))
147
148 define Package/kmod-$(1)
149 TITLE:=$(TITLE)
150 SECTION:=kernel
151 CATEGORY:=Kernel modules
152 DESCRIPTION:=$(DESCRIPTION)
153 EXTRA_DEPENDS:=kernel (=$(LINUX_VERSION)-$(LINUX_RELEASE)-$(LINUX_VERMAGIC))
154 VERSION:=$(LINUX_VERSION)$(if $(PKG_VERSION),+$(PKG_VERSION))-$(if $(PKG_RELEASE),$(PKG_RELEASE),$(LINUX_RELEASE))
155 $(call KernelPackage/$(1))
156 $(call KernelPackage/$(1)/$(BOARD))
157 endef
158
159 ifdef KernelPackage/$(1)/description
160 define Package/kmod-$(1)/description
161 $(call KernelPackage/$(1)/description)
162 endef
163 endif
164
165 ifdef KernelPackage/$(1)/config
166 define Package/kmod-$(1)/config
167 $(call KernelPackage/$(1)/config)
168 endef
169 endif
170
171 $(call KernelPackage/depends)
172
173 ifneq ($(if $(filter-out %=y %=n %=m,$(KCONFIG)),$(filter m y,$(foreach c,$(filter-out %=y %=n %=m,$(KCONFIG)),$($(c)))),.),)
174 ifneq ($(strip $(FILES)),)
175 define Package/kmod-$(1)/install
176 @for mod in $$(FILES); do \
177 if [ -e $$$$$$$$mod ]; then \
178 mkdir -p $$(1)/$(MODULES_SUBDIR) ; \
179 $(CP) -L $$$$$$$$mod $$(1)/$(MODULES_SUBDIR)/ ; \
180 elif [ -e "$(LINUX_DIR)/modules.builtin" ]; then \
181 if grep -q "$$$$$$$${mod##$(LINUX_DIR)/}" "$(LINUX_DIR)/modules.builtin"; then \
182 echo "NOTICE: module '$$$$$$$$mod' is built-in."; \
183 else \
184 echo "ERROR: module '$$$$$$$$mod' is missing." >&2; \
185 exit 1; \
186 fi; \
187 else \
188 echo "WARNING: module '$$$$$$$$mod' missing and modules.builtin not available, assuming built-in." >&2; \
189 fi; \
190 done;
191 $(call ModuleAutoLoad,$(1),$$(1),$(AUTOLOAD))
192 $(call KernelPackage/$(1)/install,$$(1))
193 endef
194 endif
195 $(if $(CONFIG_PACKAGE_kmod-$(1)),
196 else
197 compile: $(1)-disabled
198 $(1)-disabled:
199 @echo "WARNING: kmod-$(1) is not available in the kernel config - generating empty package" >&2
200
201 define Package/kmod-$(1)/install
202 true
203 endef
204 )
205 endif
206 $$(eval $$(call BuildPackage,kmod-$(1)))
207
208 $$(IPKG_kmod-$(1)): $$(wildcard $$(FILES))
209 endef
210
211 define AutoLoad
212 add_module "$(1)" "$(2)" "$(3)";
213 endef
214
215 define AutoProbe
216 probe_module "$(1)" "$(2)";
217 endef
218
219 version_field=$(if $(word $(1),$(2)),$(word $(1),$(2)),0)
220 kernel_version_merge=$$(( ($(call version_field,1,$(1)) << 24) + ($(call version_field,2,$(1)) << 16) + ($(call version_field,3,$(1)) << 8) + $(call version_field,4,$(1)) ))
221
222 ifdef DUMP
223 kernel_version_cmp=
224 else
225 kernel_version_cmp=$(shell [ $(call kernel_version_merge,$(call split_version,$(2))) $(1) $(call kernel_version_merge,$(call split_version,$(3))) ] && echo 1 )
226 endif
227
228 CompareKernelPatchVer=$(if $(call kernel_version_cmp,-$(2),$(1),$(3)),1,0)
229
230 kernel_patchver_gt=$(call kernel_version_cmp,-gt,$(KERNEL_PATCHVER),$(1))
231 kernel_patchver_ge=$(call kernel_version_cmp,-ge,$(KERNEL_PATCHVER),$(1))
232 kernel_patchver_eq=$(call kernel_version_cmp,-eq,$(KERNEL_PATCHVER),$(1))
233 kernel_patchver_le=$(call kernel_version_cmp,-le,$(KERNEL_PATCHVER),$(1))
234 kernel_patchver_lt=$(call kernel_version_cmp,-lt,$(KERNEL_PATCHVER),$(1))
235